#!/usr/local/bin/perl

use CGI qw(:all);
use CGI::Carp qw(fatalsToBrowser);

# Copyright (c) 2007 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions, and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions, and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#   3. Redistributions must acknowledge that this software was
#      originally developed by the UCSF Computer Graphics Laboratory
#      under support by the NIH National Center for Research Resources,
#      grant P41-RR01081.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
# OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

$sacsform = new CGI;
##draw form for submission of database sequence searching
print $sacsform->header;
print $sacsform->start_html( -title=>'TOPO2 Transmembrane Protein Display', -bgcolor=>'#99FFCC');
print $sacsform->h2("<center>TOPO2<p> Transmembrane Protein Display 
Page</center>"),p;

print $sacsform->start_multipart_form(POST,"/TOPO2-run/topo2anal-adv2.pl");

print 'Use this form to display a transmembrane protein sequence with ',
a({-href=>'/TOPO2/topo2-help.html'},('TOPO2')),'.',p;

print $sacsform->hidden(-name=>'seqid',-value=>'open'),p;

print "Choose Input Type ",$sacsform->popup_menu(-name=>'seqtype',
-values=>['pastein','accession'],
-default=>'pastein', 
-labels=>{'pastein'=>'Paste in Sequence (no comments - numbers ok)',
'accession'=>'Accession or GI'}),
a({href=>'/TOPO2/seqinput.html'},' Input Help'),br;

print $sacsform->textarea(-name=>'sequence',-rows=>5,-columns=>80),p;

print a({href=>'/TOPO2/topo2-help.html#number'},'Number of segments'),'  ',
$sacsform->textfield(-name=>'inum',-size=>4,-value=>'1'),p;

print 'Enter the ',a({href=>'/TOPO2/topo2-help.html#segments'},'desired 
segment information'),' (start_position end_position segment_type)',br,
'For segment type, use ',strong("1"),' to designate a transmembrane 
segment that completely crosses the membrane',br,
'and ',strong("2"),' for a partial looping segment.',br,
'Example line:  <b>20  40  1</b>',p;

print $sacsform->textarea(-name=>'segs',-rows=>7,-columns=>30),p;

print 'Where does the ',a({href=>'/TOPO2/topo2-help.html#start'},'protein start'),'? (outside - inside) ',
$sacsform->radio_group(-name=>'where_start',-value=>['outside','inside']),p;

print "<h4>Fill in data for only those display options you want, 
and check all the relevant boxes.</h4>",p;
print "<hr>";
print dl(
dt($sacsform->checkbox(-name=>'show_outside',-value=>'1',-checked=>0,-label=>' '),
'Special ',a({href=>'/TOPO2/topo2-help.html#outside'},'outside residues'),
dd($sacsform->checkbox(-name=>'show_cys',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#cys'},'cysteine residues'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'cys_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'cys_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white')))));
print dl(
dt(),
dd($sacsform->checkbox(-name=>'show_gly',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#glycos'},'N-glycosylation sites'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'gly_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'gly_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))));
print "<hr>";
print dl(
dt($sacsform->checkbox(-name=>'show_mem',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#membrane'},'membrane residues'),
dd($sacsform->checkbox(-name=>'show_ch',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#charged'},'charged residues'),
ul('acidic residue shape #: ',$sacsform->popup_menu(-name=>'acid_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'acid_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'),br,
('basic residue shape #:  ',$sacsform->popup_menu(-name=>'base_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},-default=>'1'),
' --- desired color: ',popup_menu(-name=>'base_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))))));
print dl(
dt(),
dd($sacsform->checkbox(-name=>'show_amine',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#amine'},'amine residues'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'amine_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'amine_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))));
print dl(
dt(),
dd($sacsform->checkbox(-name=>'show_oh',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#oh'},'OH residues'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'oh_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'oh_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))));
print dl(
dt(),
dd($sacsform->checkbox(-name=>'show_arom',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#arom'},'aromatic residues'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'arom_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'arom_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))));
print dl(
dt(),
dd($sacsform->checkbox(-name=>'show_pro',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#pro'},'proline residues'),
ul('desired shape #: ',$sacsform->popup_menu(-name=>'pro_sym',
-value=>['0','1','2','3','4','5'],-labels=>{'0'=>'0 none','1'=>'1 circle',
'2'=>'2 square','3'=>'3 hexagon','4'=>'4 up arrow','5'=>'5 down arrow'},
-default=>'1'),
' --- desired color: ',popup_menu(-name=>'pro_col',
-value=>['white','black','red','orange','blue','cyan','green','yellow',
'magenta','purple'],-default=>'white'))));
print "<hr>";
print dl(
dt($sacsform->checkbox(-name=>'show_sign',-value=>'1',-checked=>0,-label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#sign'},'signature regions'),
dd('Number of signature regions',$sacsform->textfield(-name=>'signum',-size=>4,-value=>'0'),
ul('Enter the desired signatuare region information',br,
'(start_position end_position region_shape region_color)',br,
'Example line: <b>20 30 3 orange</b>'))));
print $sacsform->textarea(-name=>'regions',-rows=>5,-columns=>30),p;
print "<hr>",br;
print dl(
dt($sacsform->checkbox(-name=>'show_sp',-value=>'1',-checked=>0,label=>' '),
'Show ',a({href=>'/TOPO2/topo2-help.html#special'},'special residues'),
dd('Number of special residues',$sacsform->textfield(-name=>'spnum',-size=>4,-value=>'0'),
ul('Enter the desired special residues information (position residue_shape residue_color)',br,
'Example line: <b>77 5 purple</b>'))));
print $sacsform->textarea(-name=>'special',-rows=>5,-columns=>30),p;
print 'Show ',a({href=>'/TOPO2/topo2-help.html#show_res'},'residue characters'),'? (yes - no) ',
$sacsform->radio_group(-name=>'show_res',-value=>['yes','no']),p;

print "<hr>";
p;
print $sacsform->submit(-value=>'Submit');
print $sacsform->reset,p;

print $sacsform->endform;
print $sacsform->end_html;





















